; Begin
	R0L EQU 0x20
	R0H EQU 0x21
	R1L EQU 0x22
	R1H EQU 0x23
	R2L EQU 0x24
	R2H EQU 0x25
	R3L EQU 0x26
	R3H EQU 0x27
	R4L EQU 0x28
	R4H EQU 0x29
	R5L EQU 0x2A
	R5H EQU 0x2B
	ORG 0x0000
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0005
	ORG 0x0004
	RETFIE
L0005:	NOP
; 1: ' the 128-bit pc1 encryption algorithm
; 2: ' written with PIC Simulator IDE 4.2
; 3:
; 4: Dim x1a0(8) As Word
;       The address of 'x1a0' is 0x2D
; 5: Dim cle(16) As Byte
;       The address of 'cle' is 0x3D
; 6: Dim inputalgo(9) As Byte ' the text to encrypt or decrypt
;       The address of 'inputalgo' is 0x4D
; 7: Dim outputalgo(9) As Byte ' the resulted encrypted or decrypted text
;       The address of 'outputalgo' is 0x56
; 8: Dim x1a2 As Word
;       The address of 'x1a2' is 0x5F
; 9:
; 10: Dim inter As Word
;       The address of 'inter' is 0x61
; 11: Dim res As Word
;       The address of 'res' is 0x63
; 12: Dim ax As Word
;       The address of 'ax' is 0x65
; 13: Dim bx As Word
;       The address of 'bx' is 0x67
; 14: Dim cx As Word
;       The address of 'cx' is 0x69
; 15: Dim dx As Word
;       The address of 'dx' is 0x6B
; 16: Dim si As Word
;       The address of 'si' is 0x6D
; 17: Dim tmp As Word
;       The address of 'tmp' is 0x6F
; 18: Dim i As Byte
;       The address of 'i' is 0x71
; 19: Dim fois As Byte
;       The address of 'fois' is 0x72
; 20: Dim cc As Byte
;       The address of 'cc' is 0x73
; 21: Dim compte As Byte
;       The address of 'compte' is 0x74
; 22: Dim nb As Byte
;       The address of 'nb' is 0x75
; 23: Dim nb1 As Byte
;       The address of 'nb1' is 0x76
; 24: Dim atmp As Byte
;       The address of 'atmp' is 0x77
; 25: Dim btmp As Byte
;       The address of 'btmp' is 0x78
; 26: Dim bitmp As Bit
;       The address of 'bitmp' is 0x2C,0
; 27: Dim a16tmp As Word
;       The address of 'a16tmp' is 0x79
; 28: Dim b16tmp As Word
;       The address of 'b16tmp' is 0x7B
; 29: Dim modealgo As Byte ' modealgo = 1 encrypt, modealgo = 2 decrypt
;       The address of 'modealgo' is 0x7D
; 30:
; 31: ' We choose to encrypt the text
; 32:
; 33: ' modealgo = 1 encrypt
; 34: ' modealgo = 2 decrypt
; 35:
; 36: modealgo = 1
	MOVLW 0x01
	MOVWF 0x7D
; 37:
; 38: ' the key to encrypt the plaintext or decrypt the ciphertext
; 39:
; 40: cle(0) = 78
	MOVLW 0x4E
	MOVWF 0x3D
; 41: cle(1) = 84
	MOVLW 0x54
	MOVWF 0x3E
; 42: cle(2) = 45
	MOVLW 0x2D
	MOVWF 0x3F
; 43: cle(3) = 13
	MOVLW 0x0D
	MOVWF 0x40
; 44: cle(4) = 124
	MOVLW 0x7C
	MOVWF 0x41
; 45: cle(5) = 212
	MOVLW 0xD4
	MOVWF 0x42
; 46: cle(6) = 49
	MOVLW 0x31
	MOVWF 0x43
; 47: cle(7) = 52
	MOVLW 0x34
	MOVWF 0x44
; 48: cle(8) = 178
	MOVLW 0xB2
	MOVWF 0x45
; 49: cle(9) = 243
	MOVLW 0xF3
	MOVWF 0x46
; 50: cle(10) = 17
	MOVLW 0x11
	MOVWF 0x47
; 51: cle(11) = 221
	MOVLW 0xDD
	MOVWF 0x48
; 52: cle(12) = 74
	MOVLW 0x4A
	MOVWF 0x49
; 53: cle(13) = 153
	MOVLW 0x99
	MOVWF 0x4A
; 54: cle(14) = 237
	MOVLW 0xED
	MOVWF 0x4B
; 55: cle(15) = 85
	MOVLW 0x55
	MOVWF 0x4C
; 56:
; 57: If modealgo = 1 Then
	MOVF 0x7D,W
	SUBLW 0x01
	BTFSS STATUS,Z
	GOTO L0006
; 58:
; 59: ' the plaintext is 97 97 97 97 97 97 97 97 97 (in decimal) Or 'aaaaaaaa' (in ASCII)
; 60:
; 61: inputalgo(0) = 97
	MOVLW 0x61
	MOVWF 0x4D
; 62: inputalgo(1) = 97
	MOVLW 0x61
	MOVWF 0x4E
; 63: inputalgo(2) = 97
	MOVLW 0x61
	MOVWF 0x4F
; 64: inputalgo(3) = 97
	MOVLW 0x61
	MOVWF 0x50
; 65: inputalgo(4) = 97
	MOVLW 0x61
	MOVWF 0x51
; 66: inputalgo(5) = 97
	MOVLW 0x61
	MOVWF 0x52
; 67: inputalgo(6) = 97
	MOVLW 0x61
	MOVWF 0x53
; 68: inputalgo(7) = 97
	MOVLW 0x61
	MOVWF 0x54
; 69: inputalgo(8) = 97
	MOVLW 0x61
	MOVWF 0x55
; 70:
; 71: Endif
L0006:	MOVLW 0x1F
	ANDWF STATUS,F
; 72:
; 73: If modealgo = 2 Then
	MOVF 0x7D,W
	SUBLW 0x02
	BTFSS STATUS,Z
	GOTO L0007
; 74:
; 75: ' the ciphertext is 74 177 84 68 78 136 134 40 172 (in decimal)
; 76:
; 77: inputalgo(0) = 74
	MOVLW 0x4A
	MOVWF 0x4D
; 78: inputalgo(1) = 177
	MOVLW 0xB1
	MOVWF 0x4E
; 79: inputalgo(2) = 84
	MOVLW 0x54
	MOVWF 0x4F
; 80: inputalgo(3) = 68
	MOVLW 0x44
	MOVWF 0x50
; 81: inputalgo(4) = 78
	MOVLW 0x4E
	MOVWF 0x51
; 82: inputalgo(5) = 136
	MOVLW 0x88
	MOVWF 0x52
; 83: inputalgo(6) = 134
	MOVLW 0x86
	MOVWF 0x53
; 84: inputalgo(7) = 40
	MOVLW 0x28
	MOVWF 0x54
; 85: inputalgo(8) = 172
	MOVLW 0xAC
	MOVWF 0x55
; 86:
; 87: Endif
L0007:	MOVLW 0x1F
	ANDWF STATUS,F
; 88:
; 89: ' init the pc1 algorithm
; 90:
; 91: si = 0
	CLRF 0x6D
	CLRF 0x6E
; 92: x1a2 = 0
	CLRF 0x5F
	CLRF 0x60
; 93: i = 0
	CLRF 0x71
; 94:
; 95: For fois = 0 To 8 ' from 0 to 8 = 9 bytes to encrypt or decrypt
	MOVLW 0x00
	MOVWF 0x72
L0008:	NOP
	MOVF 0x72,W
	SUBLW 0x08
	BTFSS STATUS,C
	GOTO L0009
; 96:
; 97: cc = inputalgo(fois)
	MOVF 0x72,W
	ADDLW 0x4D
	MOVWF FSR
	MOVF INDF,W
	MOVWF 0x73
; 98: Gosub assemble
	CALL L0003
; 99:
; 100: If modealgo = 1 Then
	MOVF 0x7D,W
	SUBLW 0x01
	BTFSS STATUS,Z
	GOTO L0010
; 101:
; 102: ' xor the inputalgo byte with the key
; 103: ' cle(compte) = cle(compte) xor cc
; 104:
; 105: For compte = 0 To 15
	MOVLW 0x00
	MOVWF 0x74
L0011:	NOP
	MOVF 0x74,W
	SUBLW 0x0F
	BTFSS STATUS,C
	GOTO L0012
; 106: atmp = cle(compte)
	MOVF 0x74,W
	ADDLW 0x3D
	MOVWF FSR
	MOVF INDF,W
	MOVWF 0x77
; 107: btmp = cc
	MOVF 0x73,W
	MOVWF 0x78
; 108: Gosub xor8
	CALL L0001
; 109: cle(compte) = atmp
	MOVF 0x74,W
	ADDLW 0x3D
	MOVWF FSR
	MOVF 0x77,W
	MOVWF INDF
; 110: Next compte
	MOVLW 0x01
	ADDWF 0x74,F
	BTFSS STATUS,C
	GOTO L0011
L0012:	MOVLW 0x1F
	ANDWF STATUS,F
; 111:
; 112: Endif
L0010:	MOVLW 0x1F
	ANDWF STATUS,F
; 113:
; 114: ' encrypt or decrypt the plaintext cc
; 115: ' outputalgo(fois) = cc xor (inter.hb xor inter.lb)
; 116:
; 117: atmp = inter.HB
	MOVF 0x62,W
	MOVWF 0x77
; 118: btmp = inter.LB
	MOVF 0x61,W
	MOVWF 0x78
; 119: Gosub xor8
	CALL L0001
; 120: btmp = atmp
	MOVF 0x77,W
	MOVWF 0x78
; 121: atmp = cc
	MOVF 0x73,W
	MOVWF 0x77
; 122: Gosub xor8
	CALL L0001
; 123: cc = atmp
	MOVF 0x77,W
	MOVWF 0x73
; 124: outputalgo(fois) = cc
	MOVF 0x72,W
	ADDLW 0x56
	MOVWF FSR
	MOVF 0x73,W
	MOVWF INDF
; 125:
; 126: If modealgo = 2 Then
	MOVF 0x7D,W
	SUBLW 0x02
	BTFSS STATUS,Z
	GOTO L0013
; 127:
; 128: ' xor the inputalgo byte with the key
; 129: ' cle(compte) = cle(compte) xor cc
; 130:
; 131: For compte = 0 To 15
	MOVLW 0x00
	MOVWF 0x74
L0014:	NOP
	MOVF 0x74,W
	SUBLW 0x0F
	BTFSS STATUS,C
	GOTO L0015
; 132: atmp = cle(compte)
	MOVF 0x74,W
	ADDLW 0x3D
	MOVWF FSR
	MOVF INDF,W
	MOVWF 0x77
; 133: btmp = cc
	MOVF 0x73,W
	MOVWF 0x78
; 134: Gosub xor8
	CALL L0001
; 135: cle(compte) = atmp
	MOVF 0x74,W
	ADDLW 0x3D
	MOVWF FSR
	MOVF 0x77,W
	MOVWF INDF
; 136: Next compte
	MOVLW 0x01
	ADDWF 0x74,F
	BTFSS STATUS,C
	GOTO L0014
L0015:	MOVLW 0x1F
	ANDWF STATUS,F
; 137:
; 138: Endif
L0013:	MOVLW 0x1F
	ANDWF STATUS,F
; 139:
; 140: Next fois
	MOVLW 0x01
	ADDWF 0x72,F
	BTFSS STATUS,C
	GOTO L0008
L0009:	MOVLW 0x1F
	ANDWF STATUS,F
; 141:
; 142: ' the result encrypted or decrypted is in the outputalgo() tab
; 143:
; 144: ' End of the algorithm
; 145:
; 146: End
L0016:	GOTO L0016
; 147:
; 148: xor8:
L0001:	NOP
; 149:
; 150: bitmp = atmp.0 Xor btmp.0
	CLRW
	BTFSC 0x77,0
	ADDLW 0x01
	BTFSC 0x78,0
	XORLW 0x01
	BTFSC STATUS,Z
	BCF 0x2C,0
	BTFSS STATUS,Z
	BSF 0x2C,0
; 151: atmp.0 = bitmp
	BTFSC 0x2C,0
	BSF 0x77,0
	BTFSS 0x2C,0
	BCF 0x77,0
; 152: bitmp = atmp.1 Xor btmp.1
	CLRW
	BTFSC 0x77,1
	ADDLW 0x01
	BTFSC 0x78,1
	XORLW 0x01
	BTFSC STATUS,Z
	BCF 0x2C,0
	BTFSS STATUS,Z
	BSF 0x2C,0
; 153: atmp.1 = bitmp
	BTFSC 0x2C,0
	BSF 0x77,1
	BTFSS 0x2C,0
	BCF 0x77,1
; 154: bitmp = atmp.2 Xor btmp.2
	CLRW
	BTFSC 0x77,2
	ADDLW 0x01
	BTFSC 0x78,2
	XORLW 0x01
	BTFSC STATUS,Z
	BCF 0x2C,0
	BTFSS STATUS,Z
	BSF 0x2C,0
; 155: atmp.2 = bitmp
	BTFSC 0x2C,0
	BSF 0x77,2
	BTFSS 0x2C,0
	BCF 0x77,2
; 156: bitmp = atmp.3 Xor btmp.3
	CLRW
	BTFSC 0x77,3
	ADDLW 0x01
	BTFSC 0x78,3
	XORLW 0x01
	BTFSC STATUS,Z
	BCF 0x2C,0
	BTFSS STATUS,Z
	BSF 0x2C,0
; 157: atmp.3 = bitmp
	BTFSC 0x2C,0
	BSF 0x77,3
	BTFSS 0x2C,0
	BCF 0x77,3
; 158: bitmp = atmp.4 Xor btmp.4
	CLRW
	BTFSC 0x77,4
	ADDLW 0x01
	BTFSC 0x78,4
	XORLW 0x01
	BTFSC STATUS,Z
	BCF 0x2C,0
	BTFSS STATUS,Z
	BSF 0x2C,0
; 159: atmp.4 = bitmp
	BTFSC 0x2C,0
	BSF 0x77,4
	BTFSS 0x2C,0
	BCF 0x77,4
; 160: bitmp = atmp.5 Xor btmp.5
	CLRW
	BTFSC 0x77,5
	ADDLW 0x01
	BTFSC 0x78,5
	XORLW 0x01
	BTFSC STATUS,Z
	BCF 0x2C,0
	BTFSS STATUS,Z
	BSF 0x2C,0
; 161: atmp.5 = bitmp
	BTFSC 0x2C,0
	BSF 0x77,5
	BTFSS 0x2C,0
	BCF 0x77,5
; 162: bitmp = atmp.6 Xor btmp.6
	CLRW
	BTFSC 0x77,6
	ADDLW 0x01
	BTFSC 0x78,6
	XORLW 0x01
	BTFSC STATUS,Z
	BCF 0x2C,0
	BTFSS STATUS,Z
	BSF 0x2C,0
; 163: atmp.6 = bitmp
	BTFSC 0x2C,0
	BSF 0x77,6
	BTFSS 0x2C,0
	BCF 0x77,6
; 164: bitmp = atmp.7 Xor btmp.7
	CLRW
	BTFSC 0x77,7
	ADDLW 0x01
	BTFSC 0x78,7
	XORLW 0x01
	BTFSC STATUS,Z
	BCF 0x2C,0
	BTFSS STATUS,Z
	BSF 0x2C,0
; 165: atmp.7 = bitmp
	BTFSC 0x2C,0
	BSF 0x77,7
	BTFSS 0x2C,0
	BCF 0x77,7
; 166:
; 167: Return
	RETURN
; 168:
; 169: xor16:
L0002:	NOP
; 170:
; 171: atmp = a16tmp.HB
	MOVF 0x7A,W
	MOVWF 0x77
; 172: btmp = b16tmp.HB
	MOVF 0x7C,W
	MOVWF 0x78
; 173: Gosub xor8
	CALL L0001
; 174: a16tmp.HB = atmp
	MOVF 0x77,W
	MOVWF 0x7A
; 175:
; 176: atmp = a16tmp.LB
	MOVF 0x79,W
	MOVWF 0x77
; 177: btmp = b16tmp.LB
	MOVF 0x7B,W
	MOVWF 0x78
; 178: Gosub xor8
	CALL L0001
; 179: a16tmp.LB = atmp
	MOVF 0x77,W
	MOVWF 0x79
; 180:
; 181: Return
	RETURN
; 182:
; 183:
; 184: assemble:
L0003:	NOP
; 185:
; 186: x1a0(0) = cle(0) * 256
	MOVF 0x3D,W
	MOVWF R3L
	CLRW
	MOVWF R3H
	MOVLW 0x00
	MOVWF R1L
	MOVLW 0x01
	MOVWF R1H
	CALL M001
	MOVWF 0x2D
	MOVF R2H,W
	MOVWF 0x2E
; 187: x1a0(0) = x1a0(0) + cle(1)
	MOVF 0x2D,W
	ADDWF 0x3E,W
	MOVWF 0x2D
	MOVF 0x2E,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDLW 0x00
	MOVWF 0x2E
; 188: Gosub code
	CALL L0004
; 189: inter = res
	MOVF 0x63,W
	MOVWF 0x61
	MOVF 0x64,W
	MOVWF 0x62
; 190:
; 191: nb1 = 2
	MOVLW 0x02
	MOVWF 0x76
; 192:
; 193: For nb = 1 To 7
	MOVLW 0x01
	MOVWF 0x75
L0017:	NOP
	MOVF 0x75,W
	SUBLW 0x07
	BTFSS STATUS,C
	GOTO L0018
; 194:
; 195: nb = nb - 1
	MOVLW 0x01
	SUBWF 0x75,W
	MOVWF 0x75
; 196: tmp = x1a0(nb)
	BCF STATUS,C
	RLF 0x75,W
	ADDLW 0x2D
	MOVWF FSR
	MOVF INDF,W
	MOVWF 0x6F
	INCF FSR,F
	MOVF INDF,W
	MOVWF 0x70
; 197: nb = nb + 1
	MOVF 0x75,W
	ADDLW 0x01
	MOVWF 0x75
; 198: x1a0(nb) = cle(nb1) * 256
	MOVF 0x76,W
	ADDLW 0x3D
	MOVWF FSR
	MOVF INDF,W
	MOVWF R3L
	CLRW
	MOVWF R3H
	MOVLW 0x00
	MOVWF R1L
	MOVLW 0x01
	MOVWF R1H
	CALL M001
	MOVWF R5L
	BCF STATUS,C
	RLF 0x75,W
	ADDLW 0x2D
	MOVWF FSR
	MOVF R5L,W
	MOVWF INDF
	INCF FSR,F
	MOVF R2H,W
	MOVWF INDF
; 199: nb1 = nb1 + 1
	MOVF 0x76,W
	ADDLW 0x01
	MOVWF 0x76
; 200: x1a0(nb) = x1a0(nb) + cle(nb1)
	BCF STATUS,C
	RLF 0x75,W
	ADDLW 0x2D
	MOVWF FSR
	MOVF INDF,W
	MOVWF R0L
	INCF FSR,F
	MOVF INDF,W
	MOVWF R0H
	MOVF 0x76,W
	ADDLW 0x3D
	MOVWF FSR
	MOVF INDF,W
	MOVWF R1L
	CLRW
	MOVWF R1H
	BCF STATUS,C
	RLF 0x75,W
	ADDLW 0x2D
	MOVWF FSR
	MOVF R0L,W
	ADDWF R1L,W
	MOVWF INDF
	INCF FSR,F
	MOVF R0H,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDWF R1H,W
	MOVWF INDF
; 201:
; 202: ' x1a0(nb) = x1a0(nb-1) xor tmp
; 203:
; 204: a16tmp = x1a0(nb)
	BCF STATUS,C
	RLF 0x75,W
	ADDLW 0x2D
	MOVWF FSR
	MOVF INDF,W
	MOVWF 0x79
	INCF FSR,F
	MOVF INDF,W
	MOVWF 0x7A
; 205: b16tmp = tmp
	MOVF 0x6F,W
	MOVWF 0x7B
	MOVF 0x70,W
	MOVWF 0x7C
; 206: Gosub xor16
	CALL L0002
; 207: x1a0(nb) = a16tmp
	BCF STATUS,C
	RLF 0x75,W
	ADDLW 0x2D
	MOVWF FSR
	MOVF 0x79,W
	MOVWF INDF
	INCF FSR,F
	MOVF 0x7A,W
	MOVWF INDF
; 208:
; 209: Gosub code
	CALL L0004
; 210: nb1 = nb1 + 1
	MOVF 0x76,W
	ADDLW 0x01
	MOVWF 0x76
; 211:
; 212: ' inter = inter xor res
; 213:
; 214: a16tmp = inter
	MOVF 0x61,W
	MOVWF 0x79
	MOVF 0x62,W
	MOVWF 0x7A
; 215: b16tmp = res
	MOVF 0x63,W
	MOVWF 0x7B
	MOVF 0x64,W
	MOVWF 0x7C
; 216: Gosub xor16
	CALL L0002
; 217: inter = a16tmp
	MOVF 0x79,W
	MOVWF 0x61
	MOVF 0x7A,W
	MOVWF 0x62
; 218:
; 219: Next nb
	MOVLW 0x01
	ADDWF 0x75,F
	BTFSS STATUS,C
	GOTO L0017
L0018:	MOVLW 0x1F
	ANDWF STATUS,F
; 220: i = 0
	CLRF 0x71
; 221:
; 222: Return
	RETURN
; 223:
; 224: code:
L0004:	NOP
; 225:
; 226: dx = x1a2 + i
	MOVF 0x5F,W
	ADDWF 0x71,W
	MOVWF 0x6B
	MOVF 0x60,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDLW 0x00
	MOVWF 0x6C
; 227: ax = x1a0(i)
	BCF STATUS,C
	RLF 0x71,W
	ADDLW 0x2D
	MOVWF FSR
	MOVF INDF,W
	MOVWF 0x65
	INCF FSR,F
	MOVF INDF,W
	MOVWF 0x66
; 228: cx = 346
	MOVLW 0x5A
	MOVWF 0x69
	MOVLW 0x01
	MOVWF 0x6A
; 229: bx = 20021
	MOVLW 0x35
	MOVWF 0x67
	MOVLW 0x4E
	MOVWF 0x68
; 230:
; 231: tmp = ax
	MOVF 0x65,W
	MOVWF 0x6F
	MOVF 0x66,W
	MOVWF 0x70
; 232: ax = si
	MOVF 0x6D,W
	MOVWF 0x65
	MOVF 0x6E,W
	MOVWF 0x66
; 233: si = tmp
	MOVF 0x6F,W
	MOVWF 0x6D
	MOVF 0x70,W
	MOVWF 0x6E
; 234:
; 235: tmp = ax
	MOVF 0x65,W
	MOVWF 0x6F
	MOVF 0x66,W
	MOVWF 0x70
; 236: ax = dx
	MOVF 0x6B,W
	MOVWF 0x65
	MOVF 0x6C,W
	MOVWF 0x66
; 237: dx = tmp
	MOVF 0x6F,W
	MOVWF 0x6B
	MOVF 0x70,W
	MOVWF 0x6C
; 238:
; 239: If ax <> 0 Then
	MOVF 0x65,W
	MOVWF R0L
	MOVF 0x66,W
	MOVWF R0H
	MOVLW 0x00
	MOVWF R1H
	MOVLW 0x00
	CALL C002
	BTFSS STATUS,Z
	GOTO L0019
; 240: ax = ax * bx
	MOVF 0x65,W
	MOVWF R3L
	MOVF 0x66,W
	MOVWF R3H
	MOVF 0x67,W
	MOVWF R1L
	MOVF 0x68,W
	MOVWF R1H
	CALL M001
	MOVWF 0x65
	MOVF R2H,W
	MOVWF 0x66
; 241: Endif
L0019:	MOVLW 0x1F
	ANDWF STATUS,F
; 242:
; 243: tmp = ax
	MOVF 0x65,W
	MOVWF 0x6F
	MOVF 0x66,W
	MOVWF 0x70
; 244: ax = cx
	MOVF 0x69,W
	MOVWF 0x65
	MOVF 0x6A,W
	MOVWF 0x66
; 245: cx = tmp
	MOVF 0x6F,W
	MOVWF 0x69
	MOVF 0x70,W
	MOVWF 0x6A
; 246:
; 247: If ax <> 0 Then
	MOVF 0x65,W
	MOVWF R0L
	MOVF 0x66,W
	MOVWF R0H
	MOVLW 0x00
	MOVWF R1H
	MOVLW 0x00
	CALL C002
	BTFSS STATUS,Z
	GOTO L0020
; 248: ax = ax * si
	MOVF 0x65,W
	MOVWF R3L
	MOVF 0x66,W
	MOVWF R3H
	MOVF 0x6D,W
	MOVWF R1L
	MOVF 0x6E,W
	MOVWF R1H
	CALL M001
	MOVWF 0x65
	MOVF R2H,W
	MOVWF 0x66
; 249: cx = ax + cx
	MOVF 0x65,W
	ADDWF 0x69,W
	MOVWF 0x69
	MOVF 0x66,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDWF 0x6A,W
	MOVWF 0x6A
; 250: Endif
L0020:	MOVLW 0x1F
	ANDWF STATUS,F
; 251:
; 252: tmp = ax
	MOVF 0x65,W
	MOVWF 0x6F
	MOVF 0x66,W
	MOVWF 0x70
; 253: ax = si
	MOVF 0x6D,W
	MOVWF 0x65
	MOVF 0x6E,W
	MOVWF 0x66
; 254: si = tmp
	MOVF 0x6F,W
	MOVWF 0x6D
	MOVF 0x70,W
	MOVWF 0x6E
; 255: ax = ax * bx
	MOVF 0x65,W
	MOVWF R3L
	MOVF 0x66,W
	MOVWF R3H
	MOVF 0x67,W
	MOVWF R1L
	MOVF 0x68,W
	MOVWF R1H
	CALL M001
	MOVWF 0x65
	MOVF R2H,W
	MOVWF 0x66
; 256: dx = cx + dx
	MOVF 0x69,W
	ADDWF 0x6B,W
	MOVWF 0x6B
	MOVF 0x6A,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDWF 0x6C,W
	MOVWF 0x6C
; 257:
; 258: ax = ax + 1
	MOVF 0x65,W
	ADDLW 0x01
	MOVWF 0x65
	MOVF 0x66,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDLW 0x00
	MOVWF 0x66
; 259:
; 260: x1a2 = dx
	MOVF 0x6B,W
	MOVWF 0x5F
	MOVF 0x6C,W
	MOVWF 0x60
; 261: x1a0(i) = ax
	BCF STATUS,C
	RLF 0x71,W
	ADDLW 0x2D
	MOVWF FSR
	MOVF 0x65,W
	MOVWF INDF
	INCF FSR,F
	MOVF 0x66,W
	MOVWF INDF
; 262:
; 263: ' res = ax xor dx
; 264:
; 265: a16tmp = ax
	MOVF 0x65,W
	MOVWF 0x79
	MOVF 0x66,W
	MOVWF 0x7A
; 266: b16tmp = dx
	MOVF 0x6B,W
	MOVWF 0x7B
	MOVF 0x6C,W
	MOVWF 0x7C
; 267: Gosub xor16
	CALL L0002
; 268: res = a16tmp
	MOVF 0x79,W
	MOVWF 0x63
	MOVF 0x7A,W
	MOVWF 0x64
; 269:
; 270: i = i + 1
	MOVF 0x71,W
	ADDLW 0x01
	MOVWF 0x71
; 271: Return
	RETURN
; 272:
; End of program
L0021:	GOTO L0021
; Multiplication Routine
M001:	MOVLW 0x10
	MOVWF R4L
	CLRF R0H
	CLRF R0L
M002:	RRF R3H,F
	RRF R3L,F
	BTFSS STATUS,C
	GOTO M003
	MOVF R1L,W
	ADDWF R0L,F
	MOVF R1H,W
	BTFSC STATUS,C
	INCFSZ R1H,W
	ADDWF R0H,F
M003:	RRF R0H,F
	RRF R0L,F
	RRF R2H,F
	RRF R2L,F
	DECFSZ R4L,F
	GOTO M002
	MOVF R2L,W
	RETURN
; Comparison Routine
C001:	MOVWF R1L
	MOVLW 0x05
	GOTO C007
C002:	MOVWF R1L
	MOVLW 0x02
	GOTO C007
C003:	MOVWF R1L
	MOVLW 0x06
	GOTO C007
C004:	MOVWF R1L
	MOVLW 0x03
	GOTO C007
C005:	MOVWF R1L
	MOVLW 0x04
	GOTO C007
C006:	MOVWF R1L
	MOVLW 0x01
	GOTO C007
C007:	MOVWF R4L
	MOVF R1H,W
	SUBWF R0H,W
	BTFSS STATUS,Z
	GOTO C008
	MOVF R1L,W
	SUBWF R0L,W
C008:	MOVLW 0x04
	BTFSC STATUS,C
	MOVLW 0x01
	BTFSC STATUS,Z
	MOVLW 0x02
	ANDWF R4L,W
	BTFSS STATUS,Z
	MOVLW 0xFF
	RETURN
; End of listing
	END
